##############################################################
##  Requires Eggdrop1.6.0 or greater and Darkones sitebot   ##
##                     by  aCe2k                            ##
##############################################################
#     Greetings go to B0unTy for starting me off on this     #
##############################################################

# 1. First thing todo is to get gl to parse every nfo to see
#    if theres and imdb url.  Edit project-zs/zipscript/conf/zsconfig.h
#    to and set enable_accept_script from FALSE to TRUE
#
#    /* Enable/disable accept script (accept script is run, if file is ok)
#     */
#    #define enable_accept_script    TRUE
#    #define accept_script           "/bin/imdb_parse.sh"
#
# 2. Recompile your zipscript
#
# 3. Extract imdb_parse.sh from archive to your glftpd/bin
#    Remember permissions for glftpd to run it
#
# 4. Now you need to add a small script portion to your dZSbot.tcl
#    locate: proc readlog
#    Find the if statment that string compares "INVITE"
#    Insert the following line on the line above it. Insert, not replace! 
#
#    if { ! [string compare $msgtype "IMDB"] } { imdbhandler [lindex $line 7] }
#
# 5. After this you need to disable announce by section
#    A few lines down, locate if { ([denycheck "$path"] == 0 ) }
#    and edit it to look like this...
#
#    if { ([denycheck "$path"] == 0 ) && $msgtype != "IMDB" }
#
#    NB! Because of limitations in tcl/tk i have not added the last bracket in the line above.
#
# 6. Edit your eggdrops conf file and point the  source /path/to/aCe.iMDB.tcl
#      source scripts/aCe.iMDB.tcl 
#    or
#      source /glftpd/sitebot/aCe.iMDB.tcl
#    if thats where you put it
#

#################
##
## VERSION LOG
##
##
## Bugfix 1.5.7 (22-Dec-2004)
##  - Plot output or rather %outline now works
##  - Runtime output now works too
##  - Fix minor tcl/tk compatibility fix
##  - Fixed error [cant read "nfofile": no such variable]
##
## Tweak 1.5.6 (12-Dec-2004)
##  - Compatibility fix
##  - Added public !imdb command in chan for version info
##
## Version 1.5.5 (09-Oct-2004)
##  - First public release
##
#################

# Now you need to let dZSbot.tcl know what chan to output in
set chanlist(IMDB) "#dserver"

# Want announing or not? 0=announce 1=off
# Usefull if you want to disable script for some time
set disable(IMDB) 0

# Cookie string for dZSbot.tcl settings
set variables(IMDB) "%url %title %tagline %outline %genre %rating %ratbar %runtime %trailer"

# Output Splitter
# If you dont want linebrakes.. use Example 1.
# If you do, then use the char shown below to get linebreaks or edit announce(IMDB) to the char of your choise
# set splitter(CHAR) ""

# Cookie string for dZSbot.tcl chanspam

# Eksample 1 (without linebrake):
# Produses: -MySite- [iMDB] - Kill Bill Vol. 2 (2004) http://www.imdb.com/title/tt0378194/ - User rated: 8.2/10 (24,498 votes) (########..) Top 250: #118 - Genre: Action / Thriller / Drama - Trailer: Trailer: http://www.apple.com/trailers/miramax/kill_bill/volume_ii/killbill2_sm.html
#set announce(IMDB) "-%sitename- \[iMDB\] - %bold%title%bold %url - User rated: %bold%rating%bold %ratbar - %boldGenre%bold: %genre - %boldTrailer%bold: %trailer"

# Eksample 2 (with linebrake):
# Produses: 
# <dZSbot> -MySite- [iMDB] - Kill Bill Vol. 2 (2004) http://www.imdb.com/title/tt0378194/ 
# <dZSbot> -MySite- [iMDB] - User rated: 8.2/10 (24,498 votes) (########..) Top 250: #118 
# <dZSbot> -MySite- [iMDB] - Genre: Action / Thriller / Drama 
# <dZSbot> -MySite- [iMDB] - Trailer: Trailer: http://www.apple.com/trailers/miramax/kill_bill/volume_ii/killbill2_sm.html
set announce(IMDB) "-%sitename- \[iMDB\] - %bold%title%bold %url -%sitename- \[iMDB\] - %boldUser rated%bold: %bold%rating%bold %ratbar -%sitename- \[iMDB\] - %boldGenre%bold: %genre -%sitename- \[iMDB\] - %boldTrailer%bold: %trailer"

# Other Cookies that can be used are %tagline %outline %runtime


#########################################################
# ADVANCED CONFIG, EDIT _VERY_ CAREFULLY                #
#########################################################

# the apple search script
set trailersearch "http://searchcgi.apple.com/cgi-bin/sp/nph-searchpre1.pl?"
set imdb_agent "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.2; .NET CLR 1" 
set imdbv "1.5.7"

package forget http
package require http 2.3

putlog "Loaded aCe-iMDB.tcl $imdbv by aCe2k"

bind pub *|* !imdb imdb_out

proc htmlcodes {tempfile} {
  set mapfile [string map {&#34; ' &#38; & &#91; ( &#92; / &#93; ) &#123; ( &#125; ) &#161;  &#162;  &#163;  &#164;  &#165;  &#166;  &#167;  &#168;  &#169;  &#170;  &#171;  &#172;  &#173;  &#174;  } $tempfile]
  set mapfile [string map {&#175;  &#176;  &#177;  &#178;  &#179;  &#180;  &#181;  &#182;  &#183;  &#184;  &#185;  &#186;  &#187;  &#188;  &#189;  &#190;  &#191;  &#192;  &#193;  &#194;  } $mapfile]
  set mapfile [string map {&#195;  &#196;  &#197;  &#198;  &#199;  &#200;  &#201;  &#202;  &#203;  &#204;  &#205;  &#206;  &#207;  &#208;  &#209;  &#210;  &#211;  &#212;  &#213;  &#214;  } $mapfile]
  set mapfile [string map {&#215;  &#216;  &#217;  &#218;  &#219;  &#220;  &#221;  &#222;  &#223;  &#224;  &#225;  &#226;  &#227;  &#228;  &#229;  &#230;  &#231;  &#232;  &#233;  &#234;  } $mapfile]
  set mapfile [string map {&#235;  &#236;  &#237;  &#238;  &#239;  &#240;  &#241;  &#242;  &#243;  &#244;  &#245;  &#246;  &#247;  &#248;  &#249;  &#250;  &#251;  &#252;  &#253;  &#254;  } $mapfile]
  return $mapfile
}

proc announce_imdb {vars} {
  global chanlist disable variables announce
  if { $disable(IMDB) == 0 } {
    set output $announce(IMDB)
    set output [replacevar $output "%url" [lindex $vars 0]]
    set output [replacevar $output "%title" [lindex $vars 1]]
    set output [replacevar $output "%tagline" [lindex $vars 2]]
    set output [replacevar $output "%outline" [lindex $vars 3]]
    set output [replacevar $output "%genre" [lindex $vars 4]]
    set output [replacevar $output "%rating" [lindex $vars 5]]
    set output [replacevar $output "%ratbar" [lindex $vars 6]]
    set output [replacevar $output "%runtime" [lindex $vars 7]]
    set output [replacevar $output "%trailer" [lindex $vars 8]]
    set output [basicreplace $output "IMDB"]
    sndall "IMDB" "$output"
  }
}

proc imdb_out { nick uhost hand chan args } {
	global $imdbv
	putserv "PRIVMSG $chan: aCe-iMDB.tcl $imdbv by aCe2k"
}

proc imdbhandler {nfourl} {
  global imdburl imdbsearchurl imdb_agent imdb_urladdon trailersearch argv
  
  if {[regexp {title/tt[0-9]+} $nfourl imdbresult]} {
     set nfourl "http://207.171.166.140/$imdbresult/"
     set titleurl "http://www.imdb.com/$imdbresult/"
  }


  set imdb_page [::http::config -useragent $imdb_agent]
  set imdb_page [::http::geturl $nfourl]
  set imdblines [split [::http::data $imdb_page] \n]
  set numLines [llength $imdblines]
  set title "N/A" ; set tagline "N/A" ; set outline "N/A" ; set genre "N/A"
  set rating "" ; set ratbar "" ; set runtime "N/A" ; set found_imdb_trailer "N/A"


  for {set io 0} {$io < $numLines} {incr io 1} {
    set imdbline [lindex $imdblines $io]
    if {[string compare -length 7 $imdbline "<title>"] == 0} { 
      # the movie title, year, url
      set title [string range $imdbline 7 [expr [string length $imdbline] - 9]]
      set title [htmlcodes $title]
    } elseif {([regexp \[.\]*Tagline:\[.\]* $imdbline] > 0)} {
      # the tagline
      regsub -all \<\[^\>\]*\> $imdbline "" tagline
      regsub -all \\\(\[^\\\)\]*\\\) $tagline "" tagline 
      regsub -all \[\ \t\]+ $tagline " " tagline 
      regsub -all \&nbsp\; $tagline " " tagline
      set tagline [string trim $tagline " "]
      set tagline [htmlcodes $tagline]
      set tagline [lrange $tagline 1 end]
    } elseif {[regexp {<b class=\"ch\">Plot (Summary|Outline):</b>} $imdbline] > 0} {
      # the plot
      # set pos [string last > $imdbline] ; incr pos
      # set outline [string range $imdbline $pos end]
      regsub -all \<\[^\>\]*\> $imdbline "" outline
      regsub -all \\\(\[^\\\)\]*\\\) $outline "" outline 
      regsub -all \[\ \t\]+ $outline " " outline 
      regsub -all \&nbsp\; $outline " " outline
      regsub -all Plot\ Summary\: $outline "" outline
      regsub -all Plot\ Outline\: $outline "" outline
      set outline [string trim $outline]
      set outline [htmlcodes $outline]
    } elseif {([regexp \[.\]*Genres\[.\]* $imdbline] > 0)} {
      # the genre
      regsub -all \<\[^\>\]*\> $imdbline "" genre
      regsub -all \\\(\[^\\\)\]*\\\) $genre "" genre
      regsub -all \[\ \t\]+ $genre " " genre
      set genre [string trim $genre " "]
    } elseif {([regexp \[.\]*User\ Rating\[.\]* $imdbline] > 0)} { 
      # the user rating
      set go 0
      if {[string match *awaiting* [lindex $imdblines [expr $io + 1]]]} { 
        set rating "awaiting 5 votes."
        set ratbar ""
        set go 1
      }
      if {($go == 0)} {
        set imdbline2 [lindex $imdblines [expr $io + 3]] 
        set imdbline3 [lindex $imdblines [expr $io + 4]] 
        regsub -all \<\[^\>\]*\> $imdbline3 "" rating 
        regsub -all \&nbsp\; $rating " " rating 
        regsub -all \[\ \t\]+ $rating " " rating 
        set rating [string trim $rating " "] 
        set goldstars [regexp -all goldstar $imdbline2] 
        set greystars [expr 10 - $goldstars] 
        # generating the rating bar 
        set marker "#" 
        set ratbar "\00311\(\0037" 
        for {set i2 0} {$i2 < $goldstars} {incr i2 1} { 
          set ratbar "$ratbar$marker" 
        } 
        set marker "#" 
        set ratbar "$ratbar\00314" 
        for {set i3 0} {$i3 < $greystars} {incr i3 1} { 
          set ratbar "$ratbar$marker" 
        } 
        set ratbar "$ratbar\00311\)\003"
        # finding out if top250
        if {[regexp \[.\]*top\ 250\[.\]* [lindex $imdblines [expr $io + 6]]] >0} {
          set imdbline4 [lindex $imdblines [expr $io + 6]]
          regsub -all \<\[^\>\]*\> $imdbline4 "" top250
          regsub -all top\ 250\:\  $top250 "" top250
          append ratbar " Top 250: \0037" $top250
          append ratbar "\003"
        }
      }
    } elseif {([regexp \[.\]*Runtime:\[.\]* $imdbline] > 0)} {
      # the runtime
      set jj [expr $io + 1]
      set time2 [lindex $imdblines $jj]
      set runtime [htmlcodes $time2]
      }
    }

  if {($title) > 0} {
 
    set bingo 0
    set trPri 0
    set tr_usable ""    
    set trsrcaddon "&restrict=us_trailers_only&client=www_collection&access=p"
    set trquery $title
    
      # remove year from imdb title
    regsub -all \\\(\[^\\\)\]*\\\) $trquery "" trquery
    regsub -all \[\[:space:\]\]$ $trquery "" trquery
    regsub -all \  $trquery "%2B" trquery

    set trquery [string map {& and} $trquery]
    set trpage [::http::config -useragent $imdb_agent]
    set trformat [::http::formatQuery $trquery]
    set trhttpGet "${trailersearch}q=${trquery}${trsrcaddon}"
    set trpage [::http::geturl $trhttpGet]
    set trlines [split [::http::data $trpage] \}\{]
    set tr_numLines [llength $trlines]

    foreach trline [split $trlines \n] {
        # This is where we start o append usable info from page
      if {[regexp \[.\]*FONT\ Class\=\"l12\"\[.\]* $trline] > 0} { set bingo 1 }
        # Now we have reached a point in the document to stop appending
      if {[regexp \[.\]*SNIP\[.\]* $trline] > 0} { set bingo 0 ; break }
      if {[regexp \[.\]*No\ Match\ Found\[.\]* $trline] > 0} { set bingo 0 ; break }
      if {($bingo == 1) && (([regexp \[.\]*<TABLE\[.\]* $trline]) || ([regexp \[.\]*<FONT\ Class\=\"l12\">\ <A\ HREF\[.\]* $trline])) } { 
        if {[regexp \[.\]*<!--\ snippit\ row\ a\ -->\[.\]* $trline]} { 
          foreach newtrline [split $trline !] { lappend tr_usable $newtrline }
          break
        }
        lappend tr_usable $trline 
        break
      }
    }
    set truse [string tolower [lindex $tr_usable 0]]
    set trurlStart [expr [string last "href=\"" $truse] + 6]
    set trurlEnd [expr [string last "\">" $truse] - 1]
    set found_imdb_trailer [string range $truse $trurlStart $trurlEnd]
    if {$found_imdb_trailer == ""} { set found_imdb_trailer "N/A" }
  }
  
  set imdboutput "\"$titleurl\" \"$title\" \"$tagline\" \"$outline\" \"$genre\" \"$rating\" \"$ratbar\" \"$runtime\" \"$found_imdb_trailer\""
  announce_imdb $imdboutput
}
